#!/bin/bash 

PREFIX=mvideothumb
TMP=$(mktemp -d /tmp/$PREFIX.XXXXXX)
SIZE=128
FILE=$1
OFILE=$2

if [ "$#" -gt 4 -o "$#" -lt 2 -o "$#" -eq 3 ]; then
  echo " use mplayer-video-thum.sh  <input file name> <output file name>"
  exit
elif [ "$#" -eq 4 ]; then
  SIZE=$2
  FILE=$3
  OFILE=$4
fi

FILE=$(echo -e "${FILE//\%/\\x}")
LS=$(stat -c%s "${FILE:7}")

if [ $LS -lt 200000 ]; then
  /usr/bin/mplayer -really-quiet -nojoystick -nolirc -nocache -nortc -noautosub -vf scale -vo jpeg:outdir=$TMP:quality=100  -nosound -frames 1 -zoom -xy $SIZE -slave "$FILE" 
  mv  $TMP/00000001.jpg $TMP/00000004.jpg 
else
  echo "seek $((15+($RANDOM%(56)))) 1" | /usr/bin/mplayer -really-quiet -nojoystick -nolirc -nocache -nortc -noautosub -vf scale -vo jpeg:outdir=$TMP:quality=100  -nosound -frames 4 -zoom -xy $SIZE -slave "$FILE" 
fi

if [ -e $TMP/00000004.jpg ]; then
# Thumbnail Icons, letterbox centered 128x96. full filmstrips
#  /usr/bin/convert $TMP/00000004.jpg -thumbnail 128x96 -size 128x96 xc:black +swap -gravity center -composite -gravity northwest -draw 'image Over 0,0 12,100  "/usr/share/apps/videothumbnail/filmholes-big-left.png"' -draw 'image Over 116,0 12,100 "/usr/share/apps/videothumbnail/filmholes-big-right.png"' png:"$OFILE"

# Thumbnail Icons, letterbox centered 128x96, sized filmstrips
#  /usr/bin/convert $TMP/00000004.jpg -thumbnail 128x96 -gravity northwest -draw 'image Over 0,0 12,100  "/usr/share/apps/videothumbnail/filmholes-big-left.png"' -draw 'image Over 116,0 12,100 "/usr/share/apps/videothumbnail/filmholes-big-right.png"' -size 128x96 xc:black +swap -gravity center -composite png:"$OFILE"

# Thumbnail Icons, aspect preserved <= 128x96, sized filmstrips
  /usr/bin/convert $TMP/00000004.jpg -thumbnail 128x96 -draw 'image Over 0,0 12,100  "/usr/share/apps/videothumbnail/filmholes-big-left.png"' -draw 'image Over 116,0 12,100 "/usr/share/apps/videothumbnail/filmholes-big-right.png"' png:"$OFILE"

fi

rm -rf $TMP
